#include <Plasma/FrameSvg>
#include <Plasma/Theme>
#include <Plasma/Wallpaper>
#include <KApplication>
#include <qfile.h>
#include <qtextstream.h>
#include <kstandarddirs.h>

#include <Plasma/Plasma>
#include <QPainter>

#include <QTime>
#include <QImage>
#include <QString>
#include <QPainter>
#include <QPixmap>
#include <QDesktopWidget>

#include <KIcon>

using namespace std;


#include <kcmdlineargs.h>
#include <klocale.h>
#include <kaboutdata.h>


//------------------------------------------------------------


void saveXMLFile(QString fileName,  QSize boxSize, QSize footerSize)
{
  QFile f(fileName);

  if (f.open(QFile::WriteOnly | QFile::Truncate)) {
    QTextStream out(&f);

  Plasma::FrameSvg svg;
  svg.setImagePath("widgets/background");
  svg.setEnabledBorders(Plasma::FrameSvg::AllBorders);
  svg.resizeFrame(boxSize);

  qreal left = 0;
  qreal top = 0;
  qreal right = 0;
  qreal bottom = 0;

  svg.getMargins(left,top,right,bottom);

  svg.setImagePath("widgets/panel-background");
  svg.setEnabledBorders(Plasma::FrameSvg::TopBorder);
  svg.resizeFrame(footerSize);
  svg.setElementPrefix("south");

  qreal footerTop = 0;
  qreal notUsed = 0;

  svg.getMargins(notUsed,footerTop,notUsed,notUsed);

 out << QString("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\
<!DOCTYPE greeter SYSTEM \"greeter.dtd\">\n\
<!--\n\
Copyright 2009 Lionel Chauvin <megabigbug @ yahoo.fr>\n\
Copyright 2008 Urs Wolfer <uwolfer @ kde.org>\n\
Copyright 2008 Oswald Buddenhagen <ossi @ kde.org>\n\
\n\
This program is free software; you can redistribute it and/or\n\
modify it under the terms of the GNU General Public License as\n\
published by the Free Software Foundation; either version 2 of \n\
the License, or (at your option) any later version.\n\
\n\
This program is distributed in the hope that it will be useful,\n\
but WITHOUT ANY WARRANTY; without even the implied warranty of\n\
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the\n\
GNU General Public License for more details.\n\
\n\
You should have received a copy of the GNU General Public License\n\
along with this program.  If not, see <http://www.gnu.org/licenses/>.\n\
-->\n\
<greeter id=\"theme\">\n\
	<style font=\"Sans 12\" window-text-color=\"#ffffff\"\n\
	       base-color=\"#ffffff\" alternate-base-color=\"#eeeeee\"\n\
	       text-color=\"#000000\" disabled-text-color=\"#808080\"/>\n\
	<item type=\"pixmap\" id=\"background\" background=\"true\">\n\
		<normal file=\"background0.png\"/>\n\
		<pos anchor=\"c\" x=\"50%\" y=\"50%\" width=\"100%\" height=\"100%\"/>\n\
	</item>\n\
\n\
	<item type=\"rect\" id=\"greeter\">\n\
		<pos y=\"50%\" x=\"50%\" anchor=\"c\" width=\"box\" height=\"box\"/>\n\
\n\
		<fixed>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"leftTop.png\"/>\n\
				<pos anchor=\"nw\" x=\"0\" y=\"0\" width=\"%1\" height=\"%2\"/>\n\
			</item>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"top.png\"/>\n\
				<pos anchor=\"nw\" x=\"%1\" y=\"0\" width=\"%5\" height=\"%2\"/>\n\
			</item>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"rightTop.png\"/>\n\
				<pos anchor=\"ne\" x=\"-0\" y=\"0\" width=\"%3\" height=\"%2\"/>\n\
			</item>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"left.png\"/>\n\
				<pos anchor=\"nw\" x=\"0\" y=\"%2\" width=\"%1\" height=\"%6\"/>\n\
			</item>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"center.png\"/>\n\
				<pos anchor=\"nw\" x=\"%1\" y=\"%2\" width=\"%5\" height=\"%6\"/>\n\
			</item>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"right.png\"/>\n\
				<pos anchor=\"ne\" x=\"-0\" y=\"%2\" width=\"%3\" height=\"%6\"/>\n\
			</item>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"leftBottom.png\"/>\n\
				<pos anchor=\"sw\" x=\"0\" y=\"-0\" width=\"%1\" height=\"%4\"/>\n\
			</item>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"bottom.png\"/>\n\
				<pos anchor=\"sw\" x=\"%1\" y=\"-0\" width=\"%5\" height=\"%4\"/>\n\
			</item>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"rightBottom.png\"/>\n\
				<pos anchor=\"se\" x=\"-0\" y=\"-0\" width=\"%3\" height=\"%4\"/>\n\
			</item>\n\
		</fixed>\n\
\n\
		<box orientation=\"vertical\" xpadding=\"%1\" ypadding=\"%2\" spacing=\"10\">\n\
			<item type=\"rect\" id=\"banner\">\n\
				<pos width=\"box\" height=\"box\" min-width=\"100%\"/>\n\
				<box orientation=\"horizontal\" spacing=\"10\">\n\
					<item type=\"rect\">\n\
					  <pos anchor=\"w\" y=\"50%\" width=\"box\" height=\"box\"/>\n\
					  <box>\n\
					      <item type=\"label\">\n\
						<normal color=\"#000000\" alpha=\"0.5\" font=\"Sans 16\"/>\n\
						<pos x=\"1\" y=\"1\"/>\n\
						<stock type=\"welcome-label\"/>\n\
					      </item>\n\
					  </box>\n\
					  <fixed>\n\
					    <item type=\"label\" id=\"welcome\">\n\
					      <normal color=\"#FFFFFF\" font=\"Sans 16\"/>\n\
					      <stock type=\"welcome-label\"/>\n\
					    </item>\n\
					  </fixed>\n\
					</item>\n\
\n\
					<item type=\"rect\" id=\"spacer1\">\n\
						<pos expand=\"true\"/>\n\
					</item>\n\
					<item type=\"pixmap\" id=\"branding\">\n\
						<normal file=\"kde.png\"/>\n\
					</item>\n\
				</box>\n\
			</item>\n\
			<item type=\"rect\" id=\"content\">\n\
				<pos width=\"box\" height=\"box\"/>\n\
				<box orientation=\"horizontal\" spacing=\"10\">\n\
\n\
\n\
				<item type=\"rect\" id=\"userlist-rect\">\n\
				<pos width=\"box\" height=\"box\"/>\n\
				  <box xpadding=\"2\" ypadding=\"2\">\n\
				  <item type=\"list\" id=\"userlist\" />\n\
				  </box>\n\
\n\
				  <fixed>\n\
\n\
				    <item type=\"svg\">\n\
				      <normal file=\"input-shadow.svg\" element=\"top-left\"/>\n\
				      <pos  anchor=\"nw\" x=\"0\" y=\"0\" width=\"2\" height=\"2\"/>\n\
				    </item>\n\
\n\
				    <item type=\"svg\">\n\
				      <normal file=\"input-shadow.svg\" element=\"top\"/>\n\
				      <pos anchor=\"nw\" x=\"2\" y=\"0\"  width=\"-4\" height=\"2\"/>\n\
				    </item>\n\
\n\
				    <item type=\"svg\">\n\
				      <normal file=\"input-shadow.svg\" element=\"top-right\"/>\n\
				      <pos anchor=\"ne\" x=\"-0\" y=\"0\" width=\"2\" height=\"2\"/>\n\
				    </item>\n\
\n\
				    <item type=\"svg\">\n\
				      <normal file=\"input-shadow.svg\" element=\"left\"/>\n\
				      <pos anchor=\"nw\" x=\"0\" y=\"2\" width=\"2\"  height=\"-4\" />\n\
				    </item>\n\
\n\
				    <item type=\"svg\">\n\
				      <normal file=\"input-shadow.svg\" element=\"right\"/>\n\
				      <pos anchor=\"ne\" x=\"-0\" y=\"2\" width=\"2\" height=\"-4\" />\n\
				    </item>\n\
\n\
				    <item type=\"svg\">\n\
				      <normal file=\"input-shadow.svg\" element=\"bottom-left\"/>\n\
				      <pos anchor=\"sw\" x=\"0\" y=\"-0\" width=\"2\" height=\"2\"/>\n\
				    </item>\n\
\n\
				    <item type=\"svg\">\n\
				      <normal file=\"input-shadow.svg\" element=\"bottom\"/>\n\
				      <pos anchor=\"sw\" x=\"2\" y=\"-0\" width=\"-4\" height=\"2\"/>\n\
				    </item>\n\
\n\
				    <item type=\"svg\">\n\
				      <normal file=\"input-shadow.svg\" element=\"bottom-right\"/>\n\
				      <pos anchor=\"se\" x=\"-0\" y=\"-0\" width=\"2\" height=\"2\"/>\n\
				    </item>\n\
\n\
				</fixed>\n\
\n\
			      </item>\n\
\n\
					<item type=\"rect\" id=\"verify\">\n\
						<pos width=\"box\" height=\"box\"/>\n\
						<box orientation=\"vertical\" spacing=\"2\">\n\
							<item type=\"rect\" id=\"talker\">\n\
								<pos anchor=\"n\" x=\"50%\" width=\"box\" height=\"box\"/>\n\
								<box orientation=\"vertical\" xpadding=\"2\" ypadding=\"2\" spacing=\"2\">\n\
\n\
									<item type=\"rect\">\n\
									  <pos x=\"5\" width=\"box\" height=\"box\"/>\n\
									  <box>\n\
									      <item type=\"label\">\n\
										<normal color=\"#000000\" alpha=\"0.5\" font=\"Sans 12\"/>\n\
										<pos x=\"6\" y=\"1\"/>\n\
										<stock type=\"username-label\"/>\n\
									      </item>\n\
									  </box>\n\
									  <fixed>\n\
									    <item type=\"label\">\n\
									      <pos x=\"5\"/>\n\
									      <stock type=\"username-label\"/>\n\
									    </item>\n\
									  </fixed>\n\
									</item>\n\
\n\
									<item type=\"rect\" id=\"user-entry-rect\">\n\
									  <pos x=\"0\" y=\"0\" width=\"154\" height=\"24\"/>\n\
									  <fixed>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"top-left\"/>\n\
									      <pos x=\"0\" y=\"0\" width=\"2\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"top\"/>\n\
									      <pos x=\"2\" y=\"0\" width=\"148\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"top-right\"/>\n\
									      <pos x=\"150\" y=\"0\" width=\"2\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"bottom-left\"/>\n\
									      <pos x=\"0\" y=\"20\" width=\"2\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"bottom\"/>\n\
									      <pos x=\"2\" y=\"20\" width=\"148\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"bottom-right\"/>\n\
									      <pos x=\"150\" y=\"20\" width=\"2\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"left\"/>\n\
									      <pos x=\"0\" y=\"2\" width=\"2\" height=\"18\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"right\"/>\n\
									      <pos x=\"150\" y=\"2\" width=\"2\" height=\"18\"/>\n\
									    </item>\n\
\n\
									    <item type=\"entry\" id=\"user-entry\">\n\
										<pos x=\"2\" y=\"2\" width=\"148\" height=\"18\"/>\n\
									    </item>\n\
\n\
									  </fixed>\n\
									</item>\n\
\n\
\n\
									<item type=\"rect\">\n\
									  <pos x=\"5\" width=\"box\" height=\"box\"/>\n\
									  <box>\n\
									      <item type=\"label\">\n\
										<normal color=\"#000000\" alpha=\"0.5\" font=\"Sans 12\"/>\n\
										<pos x=\"6\" y=\"1\"/>\n\
										<stock type=\"password-label\"/>\n\
									      </item>\n\
									  </box>\n\
									  <fixed>\n\
									    <item type=\"label\">\n\
									      <pos x=\"5\"/>\n\
									      <stock type=\"password-label\"/>\n\
									    </item>\n\
									  </fixed>\n\
									</item>\n\
\n\
\n\
\n\
									<item type=\"rect\" id=\"pw-entry-rect\">\n\
									  <pos x=\"0\" y=\"0\" width=\"154\" height=\"24\"/>\n\
									  <fixed>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"top-left\"/>\n\
									      <pos x=\"0\" y=\"0\" width=\"2\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"top\"/>\n\
									      <pos x=\"2\" y=\"0\" width=\"148\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"top-right\"/>\n\
									      <pos x=\"150\" y=\"0\" width=\"2\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"bottom-left\"/>\n\
									      <pos x=\"0\" y=\"20\" width=\"2\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"bottom\"/>\n\
									      <pos x=\"2\" y=\"20\" width=\"148\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"bottom-right\"/>\n\
									      <pos x=\"150\" y=\"20\" width=\"2\" height=\"2\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"left\"/>\n\
									      <pos x=\"0\" y=\"2\" width=\"2\" height=\"18\"/>\n\
									    </item>\n\
\n\
									    <item type=\"svg\">\n\
									      <normal file=\"input-shadow.svg\" element=\"right\"/>\n\
									      <pos x=\"150\" y=\"2\" width=\"2\" height=\"18\"/>\n\
									    </item>\n\
\n\
									    <item type=\"entry\" id=\"pw-entry\">\n\
										<pos x=\"2\" y=\"2\" width=\"148\" height=\"18\"/>\n\
									    </item>\n\
\n\
									  </fixed>\n\
									</item>\n\
								</box>\n\
							</item>\n\
							<item type=\"rect\" id=\"pam-error-placeholder\">\n\
								<pos width=\"100%\" height=\"box\"/>\n\
								<box orientation=\"horizontal\">\n\
									<item type=\"label\" id=\"dummy1\">\n\
										<normal alpha=\"0\" font=\"Sans Bold 12\"/>\n\
										<text/>\n\
									</item>\n\
									<item type=\"label\" id=\"pam-error\">\n\
										<pos anchor=\"c\" x=\"50%\" y=\"50%\" expand=\"true\"/>\n\
										<normal color=\"#C7C7C7\" font=\"Sans Bold 12\"/>\n\
										<text/>\n\
									</item>\n\
								</box>\n\
							</item>\n\
							<item type=\"label\" id=\"caps-lock-warning\">\n\
								<normal color=\"#C7C7C7\" font=\"Sans 12\"/>\n\
								<pos anchor=\"c\" x=\"50%\" y=\"50%\"/>\n\
								<stock type=\"caps-lock-warning\"/>\n\
							</item>\n\
						</box>\n\
					</item>\n\
				</box>\n\
			</item>\n\
		</box>\n\
\n\
	</item>\n\
\n\
	<!-- bottom bar and session buttons -->\n\
	<item type=\"rect\" id=\"footer\">\n\
		<pos x=\"0\" y=\"-0\" width=\"100%\" height=\"%9\" anchor=\"sw\"/>\n\
		<fixed>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"footerBorder.png\"/>\n\
				<pos y=\"0\" width=\"100%\" height=\"%7\"/>\n\
			</item>\n\
		</fixed>\n\
		<fixed>\n\
			<item type=\"pixmap\">\n\
				<normal file=\"footer.png\"/>\n\
				<pos y=\"%7\" width=\"100%\" height=\"%8\"/>\n\
			</item>\n\
		</fixed>\n\
		<box orientation=\"horizontal\" spacing=\"10\" xpadding=\"10\">\n\
			<item type=\"rect\" id=\"session_button\" button=\"true\">\n\
				<pos y=\"%7\" anchor=\"nw\" width=\"box\" height=\"box\"/>\n\
				<box orientation=\"horizontal\" spacing=\"10\" xpadding=\"10\">\n\
					<item type=\"pixmap\">\n\
						<normal file=\"session.png\" tint=\"#ffffff\"/>\n\
						<prelight file=\"session.png\"/>\n\
						<active file=\"session.png\" tint=\"#ffffff\"/>\n\
						<pos y=\"53%\" anchor=\"w\"/>\n\
					</item>\n\
\n\
					<item type=\"rect\">\n\
					<pos anchor=\"w\" y=\"53%\" width=\"box\" height=\"box\"/>\n\
					<box>\n\
					  <item type=\"label\">\n\
					    <normal color=\"#000000\" alpha=\"0.5\" font=\"Sans 12\"/>\n\
					    <pos x=\"1\" y=\"1\"/>\n\
					    <stock type=\"session\"/>\n\
					  </item>\n\
					</box>\n\
					<fixed>\n\
					  <item type=\"label\">\n\
						<normal color=\"#ffffff\" font=\"Sans 12\"/>\n\
						<prelight color=\"#C7C7C7\" font=\"Sans 12\"/>\n\
						<active color=\"#666666\" font=\"Sans 12\"/>\n\
						<stock type=\"session\"/>\n\
					  </item>\n\
					</fixed>\n\
				      </item>\n\
\n\
				</box>\n\
			</item>\n\
\n\
			<item type=\"rect\" id=\"system_button\" button=\"true\">\n\
				<show modes=\"console\" type=\"system\"/>\n\
				<pos y=\"%7\" anchor=\"nw\" width=\"box\" height=\"box\"/>\n\
\n\
				<box orientation=\"horizontal\" spacing=\"10\" xpadding=\"10\">\n\
					<item type=\"pixmap\">\n\
						<normal file=\"system.png\" tint=\"#ffffff\"/>\n\
						<prelight file=\"system.png\"/>\n\
						<active file=\"system.png\" tint=\"#ffffff\"/>\n\
						<pos y=\"53%\" anchor=\"w\"/>\n\
					</item>\n\
\n\
\n\
					<item type=\"rect\">\n\
					<pos anchor=\"w\" y=\"53%\" width=\"box\" height=\"box\"/>\n\
					<box>\n\
					  <item type=\"label\">\n\
					    <normal color=\"#000000\" alpha=\"0.5\" font=\"Sans 12\"/>\n\
					    <pos x=\"1\" y=\"1\"/>\n\
					    <stock type=\"system\"/>\n\
					  </item>\n\
					</box>\n\
					<fixed>\n\
					  <item type=\"label\">\n\
						<normal color=\"#ffffff\" font=\"Sans 12\"/>\n\
						<prelight color=\"#C7C7C7\" font=\"Sans 12\"/>\n\
						<active color=\"#666666\" font=\"Sans 12\"/>\n\
						<stock type=\"system\"/>\n\
					  </item>\n\
					</fixed>\n\
				      </item>\n\
\n\
\n\
				</box>\n\
			</item>\n\
			<item type=\"rect\" id=\"spacer2\">\n\
				<pos expand=\"true\"/>\n\
			</item>\n\
\n\
\n\
\n\
\n\
\n\
			<item type=\"rect\">\n\
				<show modes=\"console\" type=\"system\"/>\n\
				<pos y=\"%7\" anchor=\"nw\" width=\"box\" height=\"%8\"/>\n\
				<box orientation=\"horizontal\">\n\
					<item type=\"rect\">\n\
					<pos anchor=\"w\" y=\"53%\" width=\"box\" height=\"box\"/>\n\
					<box>\n\
					  <item type=\"label\">\n\
					      <normal color=\"#000000\" alpha=\"0.5\" font=\"Sans 12\"/>\n\
					      <pos x=\"1\" y=\"1\"/>\n\
					      <text>%c</text>\n\
					  </item>\n\
					</box>\n\
					<fixed>\n\
					  <item type=\"label\"  id=\"clock\">\n\
					    <text>%c</text>\n\
					   </item>\n\
					</fixed>\n\
				      </item>\n\
\n\
\n\
				</box>\n\
			</item>\n\
			<item type=\"rect\" id=\"spacer3\">\n\
				<pos width=\"15\"/>\n\
			</item>\n\
		</box>\n\
	</item>\n\
\n\
\n\
</greeter>\n\
").arg(left).arg(top).arg(right).arg(bottom).arg(-left-right).arg(-top-bottom).arg(footerTop).arg(footerSize.height()).arg(footerSize.height()+footerTop);


  f.close();
  }
}

void saveDesktopFile(QString desktopFileName, QString xmlFileName)
{
  QFile f(desktopFileName);

  if (f.open(QFile::WriteOnly | QFile::Truncate)) {
    QTextStream out(&f);
    out << "[KdmGreeterTheme]\n\
Greeter="+xmlFileName+"\n\
Name=MyKdmTheme\n\
Description=Install a kdm theme based on your plasma settings\n\
Author=Lionel Chauvin\n\
Copyright=GPL\n\
Screenshot=screenshot.png\n";
  f.close();
  }

}


void saveThemeElement(QString filename, int x, int y, int w, int h, QPixmap svg)
{
  QPixmap pixmap(w,h);
  pixmap.fill(Qt::transparent);
  QPainter p(&pixmap);
  p.drawPixmap(pixmap.rect(),svg,QRectF(x,y,w,h));
  p.end();
  pixmap.save(filename,"PNG");
}


void saveBoxPixmaps(QString themePath ,QSize s)
{
  Plasma::FrameSvg svg;
  svg.setImagePath("widgets/background");
  svg.setEnabledBorders(Plasma::FrameSvg::AllBorders);
  svg.resizeFrame(s);

  qreal left = 0;
  qreal top = 0;
  qreal right = 0;
  qreal bottom = 0;

  svg.getMargins(left,top,right,bottom);

  QPixmap framePixmap=svg.framePixmap();

  int centerHeight=s.height()-top-bottom;
  int centerWidth=s.width()-left-right;
  
  saveThemeElement(themePath+"leftTop.png",0,0,left,top,framePixmap);
  saveThemeElement(themePath+"top.png",left,0,centerWidth,top,framePixmap);
  saveThemeElement(themePath+"rightTop.png",left+centerWidth,0,right,top,framePixmap);
  saveThemeElement(themePath+"left.png",0,top,left,centerHeight,framePixmap);
  saveThemeElement(themePath+"center.png",left,top,centerWidth,centerHeight,framePixmap);
  saveThemeElement(themePath+"right.png",left+centerWidth,top,right,centerHeight,framePixmap);
  saveThemeElement(themePath+"leftBottom.png",0,top+centerHeight,left,bottom,framePixmap);
  saveThemeElement(themePath+"bottom.png",left,top+centerHeight,centerWidth,bottom,framePixmap);
  saveThemeElement(themePath+"rightBottom.png",left+centerWidth,top+centerHeight,right,bottom,framePixmap);

}



void saveFooterPixmaps(QString themePath ,QSize s)
{
  Plasma::FrameSvg svg;
  svg.setImagePath("widgets/panel-background");
  svg.setEnabledBorders(Plasma::FrameSvg::TopBorder);
  svg.resizeFrame(s);
  svg.setElementPrefix("south");

  qreal left = 0;
  qreal top = 0;
  qreal right = 0;
  qreal bottom = 0;

  svg.getMargins(left,top,right,bottom);

  QPixmap framePixmap=svg.framePixmap();

  saveThemeElement(themePath+"footer.png",0,top,s.width(),s.height()-top,framePixmap);
  saveThemeElement(themePath+"footerBorder.png",0,0,s.width(),top,framePixmap);

}


//-------------------------------------------------------------------------------------


Plasma::Wallpaper *loadWallpaper(KConfigGroup wallpaperConfig, KConfigGroup containment)
{
  Plasma::Wallpaper *w=Plasma::Wallpaper::load(containment.readEntry("wallpaperplugin"));

  if (w!=NULL){
	  
    w->setBoundingRect(containment.readEntry<QRectF>("geometry",QRectF(0,0,1024,768)));
    w->setRenderingMode(containment.readEntry("wallpaperpluginmode"));
    w->restore(wallpaperConfig);

    QTime dieTime = QTime::currentTime().addMSecs(1000);
    while( QTime::currentTime() < dieTime )
    QCoreApplication::processEvents(QEventLoop::AllEvents, 100);
  }

  return w;
}



void paintWallpaper(Plasma::Wallpaper *w, QPixmap *pixmap, float x, float y, float width, float height)
{
    QPainter painter(pixmap);
    painter.translate(x,y);
    w->paint(&painter,QRectF(0,0,width,height));
    painter.translate(-x,-y);
}

void saveVisibleWallpaper(QString baseFilename)
{

  QString config_file=KStandardDirs::locateLocal("config", "plasma-desktop-appletsrc"); //for kde 4.3
  if (!QFile(config_file).exists()) config_file=KStandardDirs::locateLocal("config", "plasma-appletsrc"); //for kde 4.2 

  KConfig plasma_appletsrc(config_file);

  KConfigGroup containments = plasma_appletsrc.group("Containments");

  foreach (const QString containmentNumber, containments.groupList()) { //eg. [Containment][15]

    KConfigGroup containment(&containments, containmentNumber);

    if (containment.readEntry("screen").toInt()>=0) {

      foreach (const QString containmentType, containment.groupList()) { //eg. [Containment][15][Wallpaper]    
	  
	if (containmentType=="Wallpaper"){ //if it is a wallpaper
	  KConfigGroup wallpaper(&containment, "Wallpaper");
	    
	  foreach (const QString plugin, wallpaper.groupList()) { //eg. [Containment][15][Wallpaper][image]
	  // kDebug() << containmentNumber << containmentType << plugin;
	    KConfigGroup wallpaperConfig(&wallpaper, plugin);

	    Plasma::Wallpaper *w=loadWallpaper(wallpaperConfig, containment);
	    if (w!=NULL)
	    {
	      
	      QRectF containementRect=containment.readEntry<QRectF>("geometry",QRectF(0,0,1024,768));

	      QPixmap pixmap(containementRect.width(), containementRect.height());
	      pixmap.fill(Qt::transparent);

	      paintWallpaper(w, &pixmap,0,0,containementRect.width(),containementRect.height());

	      pixmap.save(baseFilename+containment.readEntry("screen")+".png", "PNG");

	      delete w;
	    }
	  }
	}     
      }
    }
  }

}




void saveIcons(QString themePath, int size)
{
  KIcon("start-here-kde").pixmap(size,QIcon::Normal).save(themePath+"kde.png");
  KIcon("preferences-system-login").pixmap(size,QIcon::Normal).save(themePath+"system.png");
  KIcon("applications-system").pixmap(size,QIcon::Normal).save(themePath+"session.png");
  
}

//-------------------------------------------------------------------------------------


int main( int argc, char **argv )
{

  
  KAboutData aboutData( "KdmThemeGenerator", 
			"KdmThemeGenerator", 
			ki18n("KdmThemeGenerator"), 
			"1.0", 
			ki18n("A theme generator for kdm"),
			KAboutData::License_GPL, ki18n("Copyright (c) 2009 Lionel Chauvin") );

  KCmdLineArgs::init( argc, argv, &aboutData );

  KApplication a;

  QString myKdmheme= KGlobal::dirs()->localkdedir()+"share/apps/kdm/themes/MyKdmTheme/";

  if (!QFile(myKdmheme).exists())  KStandardDirs::makeDir(myKdmheme,0755);
  
  QSize boxSize(390, 234);
  QSize footerSize(QApplication::desktop()->screenGeometry(0).width(), 36);

  saveBoxPixmaps(myKdmheme, boxSize);
  saveFooterPixmaps(myKdmheme, footerSize);

  saveXMLFile(myKdmheme+"MyKdmTheme.xml", boxSize, footerSize);

  saveDesktopFile(myKdmheme+"KdmGreeterTheme.desktop","MyKdmTheme.xml");

  QFile::copy("input-shadow.svg", myKdmheme+"input-shadow.svg");

  saveVisibleWallpaper(myKdmheme+"background");

  saveIcons(myKdmheme,32);

  return 0;
}



/*
#include <Plasma/FrameSvg>
#include <Plasma/Theme>
#include <KApplication>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <KIconEffect>
int main( int argc, char **argv )
{

  KAboutData aboutData( "test", 
            "test", 
            ki18n("test"), 
            "1.0", 
            ki18n("plasma panel rendering test"),
            KAboutData::License_GPL, ki18n("Copyright (c) 2009 Lionel Chauvin")
);

  KCmdLineArgs::init( argc, argv, &aboutData );

  KApplication a;


  //Plasma::Theme::defaultTheme()->setUseGlobalSettings(false);
  //Plasma::Theme::defaultTheme()->setThemeName("Atelier");

  Plasma::FrameSvg svg;
 
  svg.setImagePath(Plasma::Theme::defaultTheme()->imagePath("widgets/background"));
  svg.setEnabledBorders(Plasma::FrameSvg::AllBorders);
  svg.resizeFrame(QSizeF(200,200));
  QPixmap p=svg.framePixmap();

  p.save("test.png", "PNG");

  return 0;
}

*/
